/*  xscrbuf.c
 *    version 0.2
 *    by Yusuke Shinyama
 */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Shell.h>
#include <X11/Xmu/Atoms.h>
#include <unistd.h> 
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>
#include <errno.h>

static void received(Widget w, XtPointer data, Atom* selectin, Atom* type,
		     XtPointer value, unsigned long* length, int* format) 
{
  if (*type == 0 || *length == 0 || value == NULL) {
    int nbytes;
    char* buff;
    buff = (void*)XFetchBuffer(XtDisplay(w), &nbytes, 0);
    if (nbytes == 0) exit(1);
    write(1, buff, nbytes);
  } else {
    write(1, value, *length);
  }
  exit(0);
}

int main(int argc, char* argv[])
{
  XtAppContext context;
  Widget w;
  w = XtVaOpenApplication(&context, "XScrBuf", NULL, 0, 
			  &argc, argv, NULL, shellWidgetClass,				 
			  XtNwidth, 1, XtNheight, 1, 0, 0);
  XtSetMappedWhenManaged(w, False);
  XtRealizeWidget(w);
  XtGetSelectionValue(w, XA_PRIMARY, XA_TEXT(XtDisplay(w)), received, None, 0);
  XtAppMainLoop(context);
  exit(0);
}
